/*
 * This file is part of source for dviviewer, 
 * a DVI file viewer for Qtopia environment. 
 * 
 * Copyright (C) 2003  hn43o.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef DVI_H
#define DVI_H

#include <qfile.h>
#include <qintdict.h>
#include <qvaluelist.h>
#include <qvaluestack.h>

#include "binaryfile.h"
#include "dvipainter.h"

class Dvi : public BinaryFile {
 public:
  Dvi();
  ~Dvi();
  bool open( QString );
  void drawPage( DviPainter *, int page );
  QValueList<int> pages();
  
 private:
  void readInfo();

  bool isPTeX;
  unsigned int scaleFactor, designSize, magnification;
  QString comment;

  unsigned int postPosition;
  QValueList<int> bopPosition;
  QValueList<int> pageNumber;

  typedef struct {
	uint h, v, w, x, y, z; 
  } CurrentData;
  QValueStack<CurrentData> stack;
  CurrentData cur;
  typedef struct {
	uint c, s, d, a, l;
	QString n;
  } FontData;
  QIntDict<FontData> fonts;
  int fontNo;
  uchar direction;
};

#endif
