/*
 * This file is part of source for dviviewer, 
 * a DVI file viewer for Qtopia environment. 
 * 
 * Copyright (C) 2003  hn43o.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef JPFONT_H
#define JPFONT_H

#include <qmap.h>

#include "binaryfile.h"
#include "texfont.h"

class QTextCodec;

class JpFont : public TexFont {
 public:
  JpFont();
  bool open( QString );
  bool openByName( QString );
  //  void close();
  uint dx( uint );
  uint width( uint );
  uint height( uint );
  int hoff( uint );
  int voff( uint );
  uint tfm( uint );
  uint designSize();
  void setDpi( uint );
  void draw( QPainter *, int x, int y, uint code );

 private: 
  void readInfo();

  uint _designSize;

  uint dpi;
  bool isBold;
  QArray<uint> _width, _height, _depth, _italic;
  QMap<uint, uint> charType;
  typedef struct {
    uchar widthIndex, heightIndex, depthIndex, italicIndex;
  } CharInfo;
  QArray<CharInfo> charInfo;
  QTextCodec *codec;
};

#endif
