/*
 * This file is part of source for dviviewer, 
 * a DVI file viewer for Qtopia environment. 
 * 
 * Copyright (C) 2003  hn43o.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef TEXFONT_H
#define TEXFONT_H

#include "binaryfile.h"
class QString;
class QPainter;

class TexFont : public BinaryFile {
 public:
  virtual bool openByName( QString ) = 0;
  virtual uint dx( uint ) = 0;
  virtual uint width( uint ) = 0;
  virtual uint height( uint ) = 0;
  virtual int hoff( uint ) = 0;
  virtual int voff( uint ) = 0;
  virtual uint tfm( uint ) = 0;
  virtual uint designSize() = 0;
  virtual void setDpi( uint ) = 0;
  virtual void draw( QPainter *, int x, int y, uint code ) = 0;
};

#endif
